love.filesystem.load("image.lua")()
love.filesystem.load("config.lua")()
love.filesystem.load("bullet.lua")()

player_mt = {}
player_mt.__index = player_mt

function math.getAngle(x1,y1, x2,y2) return math.atan2(y2-y1, x2-x1) end
changeTime = 0

function getPlayer()
    player = {}
	player.img = getPlayerImg()
	player.x = 400
	player.y = 600
	player.xSpeed = 400
	player.ySpeed = 400
	player.bullets = getBullets()
	player.bulletSpeed = 200
	player.fireRate = .1
	player.lastFired = 0
	player.shotTypes = {'Spread', 'Back Spread', 'Two in the Back', 'Two in the Front', 'Plus', 'Explodey'}
	player.shotIndex = 1
	player.shotType = player.shotTypes[player.shotIndex]
	return setmetatable(player, player_mt)
end

function player_mt:update(dt)
    if love.keyboard.isDown(keyBind.right) then
		player.x = player.x + player.xSpeed*dt
	end
	if love.keyboard.isDown(keyBind.left) then
	    player.x = player.x - player.xSpeed*dt
	end
	if love.keyboard.isDown(keyBind.up) then
	    player.y = player.y - player.ySpeed*dt
	end
	if love.keyboard.isDown(keyBind.down) then
	    player.y = player.y + player.ySpeed*dt
	end
	if love.keyboard.isDown('tab') then
		if changeTime == 0 then
			player.shotIndex = player.shotIndex + 1
			if player.shotIndex > #player.shotTypes then
				player.shotIndex = 1
			end
			changeTime = changeTime+dt
		end
		player.shotType = player.shotTypes[player.shotIndex]
	end
	if changeTime > 0 then
	    changeTime = changeTime+dt
	end
	if changeTime > .5 then
		changeTime = 0
	end
	if love.keyboard.isDown(' ') then
	    if player.lastFired == 0 then
		    if player.shotType == 'Spread' then
			    player.bullets:bulletSpread(player.x, player.y, -math.pi/2, player.bulletSpeed, 60, 5)
			end
			if player.shotType == 'Back Spread' then
			    player.bullets:bulletSpread(player.x, player.y, math.pi/2, player.bulletSpeed, 60, 5)
				player.bullets:addBullet(player.x+5, player.y, -math.pi/2, player.bulletSpeed)
				player.bullets:addBullet(player.x-5, player.y, -math.pi/2, player.bulletSpeed)
			end
			if player.shotType == 'Two in the Back' then
				player.bullets:addBullet(player.x, player.y, -math.pi/2, player.bulletSpeed)
			    player.bullets:addBullet(player.x+5, player.y, math.pi/2, player.bulletSpeed)
				player.bullets:addBullet(player.x-5, player.y, math.pi/2, player.bulletSpeed)
			end
			if player.shotType == 'Two in the Front' then
				player.bullets:addBullet(player.x, player.y, math.pi/2, player.bulletSpeed)
			    player.bullets:addBullet(player.x+5, player.y, -math.pi/2, player.bulletSpeed)
				player.bullets:addBullet(player.x-5, player.y, -math.pi/2, player.bulletSpeed)	
			end
			if player.shotType == 'Plus' then
				player.bullets:bulletSpread(player.x, player.y, math.pi/4, player.bulletSpeed, 360, 4)
			end
			if player.shotType == 'Explodey' then
			    player.bullets:bulletSpread(player.x, player.y, -math.pi/2, player.bulletSpeed, 360, 25)
			end
			player.lastFired = player.lastFired + dt
	    end
	end
	if player.lastFired < player.fireRate and player.lastFired > 0 then
		player.lastFired = player.lastFired + dt
	else
	    player.lastFired = 0
	end
	player.bullets:update(dt)
	if player.x < 0 then
	    player.x = 0
	end
	if player.x > love.graphics.getWidth() then
	    player.x = love.graphics.getWidth()
	end
    if player.y < 0 then
	    player.y = 0
	end
	if player.y > love.graphics.getHeight() then
	    player.y = love.graphics.getHeight()
	end
end

function player_mt:draw()
    player.bullets:draw()
	love.graphics.draw(player.img, player.x-player.img:getWidth()/2, player.y-player.img:getHeight()/2)
	love.graphics.print('Bullet Type: '..player.shotType, 50, 75)
end